import loading, gui, pygame, os, mappainter, level_loader, random, config_loader 
import sonar, units, game_timer
from pygame import *

try:
    import psyco
    psyco.background()
    print "psyco installed"
except:
    print "psyco not installed"
    pass

class game_states:
    def __init__(self):
        pygame.init()
        config_data = config_loader.load_data()
        if config_data[11] == False:
            self.background_screen = pygame.display.set_mode((640,480))
        else:
            self.background_screen = pygame.display.set_mode((640,480), FULLSCREEN)
        pygame.display.set_caption("Search for the Red Herring - 1.0")
        self.clock = pygame.time.Clock()
        self.background_screen.fill([0,0,0])
        self.on_state = 'Menu'
        self.level = 1
        self.base_fish = 0
        

    def inst_one(self):
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("help1.png", alpha = True)
        next_button = gui.Button(550, 35, 'button.png', True)
        exit_button = gui.Button(550, 425, 'button.png', True)
        next_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        exit_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        left_exit = True
        left_next = True
        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if next_button.clicked(m_d) == True:
                self.on_state = "INST-2"
                break
            if exit_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break

            if next_button.do_hl == True:
                if left_next == True:
                    sound_pong.play()
                    left_next = False
            else:
                left_play = True
            if exit_button.do_hl == True:
                if left_exit == True:
                    sound_pong.play()
                    left_exit = False
            else:
                left_exit = True
            self.background_screen.blit(back, (0,0))
            next_button.draw(self.background_screen, "next")
            exit_button.draw(self.background_screen, "exit")
            pygame.display.flip()

    def inst_two(self):
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("help2.png", alpha = True)
        next_button = gui.Button(550, 35, 'button.png', True)
        back_button = gui.Button(100, 35, 'button.png', True)
        exit_button = gui.Button(550, 425, 'button.png', True)
        next_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        back_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        exit_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        left_exit = True
        left_next = True
        left_back = True
        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if next_button.clicked(m_d) == True:
                self.on_state = "INST-3"
                break
            if back_button.clicked(m_d) == True:
                self.on_state = "INST-1"
                break
            if exit_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break

            if next_button.do_hl == True:
                if left_next == True:
                    sound_pong.play()
                    left_next = False
            else:
                left_next = True
            if back_button.do_hl == True:
                if left_back == True:
                    sound_pong.play()
                    left_back = False
            else:
                left_back = True
            if exit_button.do_hl == True:
                if left_exit == True:
                    sound_pong.play()
                    left_exit = False
            else:
                left_exit = True
            self.background_screen.blit(back, (0,0))
            next_button.draw(self.background_screen, "next")
            back_button.draw(self.background_screen, "back")
            exit_button.draw(self.background_screen, "exit")
            pygame.display.flip()

    def inst_three(self):
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("help3.png", alpha = True)
        next_button = gui.Button(550, 35, 'button.png', True)
        back_button = gui.Button(100, 35, 'button.png', True)
        exit_button = gui.Button(550, 435, 'button.png', True)
        next_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        back_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        exit_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        left_exit = True
        left_next = True
        left_back = True
        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if next_button.clicked(m_d) == True:
                self.on_state = "INST-4"
                break
            if back_button.clicked(m_d) == True:
                self.on_state = "INST-2"
                break
            if exit_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break

            if next_button.do_hl == True:
                if left_next == True:
                    sound_pong.play()
                    left_next = False
            else:
                left_next = True
            if back_button.do_hl == True:
                if left_back == True:
                    sound_pong.play()
                    left_back = False
            else:
                left_back = True
            if exit_button.do_hl == True:
                if left_exit == True:
                    sound_pong.play()
                    left_exit = False
            else:
                left_exit = True
            self.background_screen.blit(back, (0,0))
            next_button.draw(self.background_screen, "next")
            back_button.draw(self.background_screen, "back")
            exit_button.draw(self.background_screen, "exit")
            pygame.display.flip()

    def inst_four(self):
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("help4.png", alpha = True)
        next_button = gui.Button(550, 35, 'button.png', True)
        back_button = gui.Button(100, 35, 'button.png', True)
        exit_button = gui.Button(550, 435, 'button.png', True)
        next_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        back_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        exit_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        left_exit = True
        left_next = True
        left_back = True
        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if next_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break
            if back_button.clicked(m_d) == True:
                self.on_state = "INST-3"
                break
            if exit_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break

            if next_button.do_hl == True:
                if left_next == True:
                    sound_pong.play()
                    left_next = False
            else:
                left_next = True
            if back_button.do_hl == True:
                if left_back == True:
                    sound_pong.play()
                    left_back = False
            else:
                left_back = True
            if exit_button.do_hl == True:
                if left_exit == True:
                    sound_pong.play()
                    left_exit = False
            else:
                left_exit = True
            self.background_screen.blit(back, (0,0))
            next_button.draw(self.background_screen, "menu")
            back_button.draw(self.background_screen, "back")
            exit_button.draw(self.background_screen, "exit")
            pygame.display.flip()
        
    def menu(self):
        config = config_loader.load_data()
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("mainmenu.png", alpha = True)
        play_button = gui.Button(415, 325, 'button.png', True)
        help_button = gui.Button(415, 365, 'button.png', True)
        exit_button = gui.Button(415, 425, 'button.png', True)
        play_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        help_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        exit_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        left_exit = True
        left_play = True
        left_help = True

        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if play_button.clicked(m_d) == True:
                self.on_state = "Play"
                break
            if help_button.clicked(m_d) == True:
                self.on_state = "INST-1"
                break
            if exit_button.clicked(m_d) == True:
                self.on_state = "Exit-Now"
                break

            if play_button.do_hl == True:
                if left_play == True:
                    sound_pong.play()
                    left_play = False
            else:
                left_play = True
            if help_button.do_hl == True:
                if left_help == True:
                    sound_pong.play()
                    left_help = False
            else:
                left_help = True
            if exit_button.do_hl == True:
                if left_exit == True:
                    sound_pong.play()
                    left_exit = False
            else:
                left_exit = True
            self.background_screen.blit(back, (0,0))
            play_button.draw(self.background_screen, "play")
            help_button.draw(self.background_screen, "instructions")
            exit_button.draw(self.background_screen, "exit")
            pygame.display.flip()

    def play(self):
        #game time!
        config_data = config_loader.load_data()
        if self.level <= 11:
            level_data = level_loader.load_data(self.level)
        else:
            level_data = level_loader.load_data(0, 10)
        
        globex, globey = level_data[1][0][0]*-50+300, level_data[1][0][1]*-50+200

        sound_boom = loading.load_sound('boom.wav')
        sound_big_boom = loading.load_sound('boom.wav')
        sound_missile = loading.load_sound('missile.wav')
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        sound_big_boom.set_volume(2.0)
        sound_missile.set_volume(0.3)
        sound_rand = loading.load_sound('seagull.wav')
        sound_rand.set_volume(0.4)
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'game.ogg'))
        music.music.play()
        
        letters = "smd!@#$%^&*12345678"
        images = ( loading.load_image('shallow_water.png')[0],
                       loading.load_image('moderate_water.png')[0],
                       loading.load_image('deep_water.png')[0],
                       
                       loading.load_image('moderate-to-shallow-BL-TR.png')[0],
                       loading.load_image('moderate-to-shallow-BR-TL.png')[0],
                       loading.load_image('moderate-to-shallow-B-T.png')[0],
                       loading.load_image('moderate-to-shallow-L-R.png')[0],
                       loading.load_image('moderate-to-shallow-R-L.png')[0],
                       loading.load_image('moderate-to-shallow-T-B.png')[0],
                       loading.load_image('moderate-to-shallow-TL-BR.png')[0],
                       loading.load_image('moderate-to-shallow-TR-BL.png')[0],

                       loading.load_image('deep-to-moderate-BL-TR.png')[0],
                       loading.load_image('deep-to-moderate-BR-TL.png')[0],
                       loading.load_image('deep-to-moderate-B-T.png')[0],
                       loading.load_image('deep-to-moderate-L-R.png')[0],
                       loading.load_image('deep-to-moderate-R-L.png')[0],
                       loading.load_image('deep-to-moderate-T-B.png')[0],
                       loading.load_image('deep-to-moderate-TL-BR.png')[0],
                       loading.load_image('deep-to-moderate-TR-BL.png')[0] )
        
        filename = "map1.plm"
        our_map = mappainter.Flat_Tile_Map(globex, globey, level_data[0][0][0], level_data[0][0][1], 50)
        our_map.load(filename)
        our_map.load_tiles(letters,images)
        

        clock = pygame.time.Clock()
        

        p_sonar = sonar.Sonar()
        timer = game_timer.Player_Timer(level_data[4])

        player_base = units.PlayerBase(level_data[6][0], self.base_fish)
        p_sonar.add_player(player_base)
        
        player = units.Player(level_data[1][0])
        p_sonar.add_player(player)
        player_explosions = []
        player_on_attack = 0
        player_attackers = []
        player_harvesters = []
        player_attack_counter = 0
        player_spawning_attack = False
        player_energy = 200
        player_energy_drain = 0
        
        enemy = units.RedHerring(level_data[3][0])
        p_sonar.add_enemy(enemy)
        enemy_attackers = []
        enemy_attack_counter = random.randint(0,30)

        shark_eaters = []


        decoys = []
        decoy_attackers = []
        decoy_attack_counter = random.randint(0,30)
        for decoy in level_data[7]:
            decoys.append(units.Decoy(decoy))
        for decoy in decoys:
            p_sonar.add_enemy(decoy)
        neut_group = []
        for neut_pos in level_data[2]:
            neut_group.append(units.Herring(neut_pos))
        for neut in neut_group:
            p_sonar.add_neut(neut)

        rocks = []
        for rock in level_data[5]:
            rocks.append(units.Rock(rock))

        exit_button = gui.Button(100, 25, 'button.png', True)
        exit_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        left_exit = True
        moving_y = 0
        moving_x = 0

        player_attack_target = enemy

        paused = False

        ambience_group = []
        for i in range(75):
            ambience_group.append(units.Ambience((random.randint(0,39),random.randint(0,39))))

        ra = 0


        while 1:
            ra += 1
            if ra == 250:
                ra = 0
                sound_rand.play()
            try:
                for neut in p_sonar.neuts:
                    p_sonar.remove_neut(neut)
                for decoy in p_sonar.enemies:
                    p_sonar.remove_enemy(decoy)
                    
                for neut in neut_group:
                    p_sonar.add_neut(neut)
                for decoy in decoys:
                    p_sonar.add_enemy(decoy)
            except:pass
                

            
            if exit_button.do_hl == True:
                if left_exit == True:
                    sound_pong.play()
                    left_exit = False
            else:
                left_exit = True
            clock.tick(30)
            #print clock.get_fps()
            
            self.background_screen.fill([0,0,0])
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break

            for event in pygame.event.get():
                if event.type == KEYDOWN:
                    if event.key == config_data[7]:
                        moving_y = 1
                    if event.key == config_data[6]:
                        moving_y = -1
                    if event.key == config_data[9]:
                        moving_x = 1
                    if event.key == config_data[8]:
                        moving_x = -1
                    if event.key == config_data[0]:
                        player_spawning_attack = True
                    if event.key == config_data[1]:
                        if player.crew >= 2:
                            if len(player_harvesters) < 2:
                                player_harvesters.append(units.PenguinHarvester(player.rect.topleft, neut_group))
                                player.crew -= 1

                    if event.key == config_data[3]:
                        if player.rect.colliderect(player_base.rect):
                            if player_base.num_fish > 0:
                                player_energy += 50
                                player_base.num_fish -= 1
                                self.base_fish -= 1

                    if event.key == config_data[4]:
                        if player_energy > 150:
                            if player.rect.colliderect(player_base.rect):
                                if player_base.num_fish < 8:
                                    player_energy -= 50
                                    player_base.num_fish += 1
                                    self.base_fish += 1

                    if event.key == config_data[5]:
                        if player_base.num_crew >= 1:
                            if player.rect.colliderect(player_base.rect):
                                if player.crew < 20:
                                    player.crew += 1
                                    player_base.num_crew -= 1

                    if event.key == config_data[2]:
                        player_on_attack += 1
                        if player_on_attack >= 3:
                            player_on_attack = 0

                    if event.key == config_data[10]:
                        if paused == False:
                            paused = True
                        else:
                            paused = False

                elif event.type == KEYUP:
                    if event.key == config_data[7]:
                        moving_y = 0
                    if event.key == config_data[6]:
                        moving_y = 0
                    if event.key == config_data[9]:
                        moving_x = 0
                    if event.key == config_data[8]:
                        moving_x = 0
                    if event.key == config_data[0]:
                        player_spawning_attack = False

            if not paused:
                if player_spawning_attack:
                    player_attack_counter += 1
                    if player_attack_counter == 10:
                        player_attack_counter = 0
                        if len(player_attackers) < 5:
                            if player_energy >= 1:
                                if player.crew >= 2:
                                    if player_on_attack == 0:
                                        player_energy -= 10
                                        player.crew -= 1
                                        player_attackers.append(units.PenguinAttack(player.rect, player_attack_target))
                                if player_on_attack == 1:
                                    player_energy -= 15
                                    player_attackers.append(units.PenguinTorpedo(player.rect, player_attack_target))
                                    sound_missile.play()
                                if player_on_attack == 2:
                                    player_energy -= 25
                                    player_attackers.append(units.PenguinLockTorpedo(player.rect, player_attack_target))
                                    sound_missile.play()
                                        


                for rock in rocks:
                    if player.small_rect.colliderect(rock.small_rect):
                        if player.rect.centerx <= rock.rect.centerx:
                            player.rect.centerx -= 3
                            globex += 3
                        else:
                            player.rect.centerx += 3
                            globex -= 3

                        if player.rect.centery <= rock.rect.centery:
                            player.rect.centery -= 3
                            globey += 3
                        else:
                            player.rect.centery += 3
                            globey -= 3

                if player.small_rect.colliderect(player_base.rect):
                    if player.rect.centerx <= player_base.rect.centerx:
                        player.rect.centerx -= 3
                        globex += 3
                    else:
                        player.rect.centerx += 3
                        globex -= 3

                    if player.rect.centery <= player_base.rect.centery:
                        player.rect.centery -= 3
                        globey += 3
                    else:
                        player.rect.centery += 3
                        globey -= 3


                if player_energy > 0:
                    if moving_x == 1:
                        globex -= moving_x*3
                        player.rect.left += moving_x*3
                        if moving_x != 0 or moving_y != 0:
                            player_energy_drain += 1
                            if player_energy_drain >= 15:
                                player_energy -= 1
                                player_energy_drain = 0
                    if moving_x == -1:
                        globex -= moving_x*3
                        player.rect.left += moving_x*3
                        if moving_x != 0 or moving_y != 0:
                            player_energy_drain += 1
                            if player_energy_drain >= 15:
                                player_energy -= 1
                                player_energy_drain = 0
                    if moving_y == 1:
                        globey -= moving_y*3
                        player.rect.top += moving_y*3
                        if moving_x != 0 or moving_y != 0:
                            player_energy_drain += 1
                            if player_energy_drain >= 15:
                                player_energy -= 1
                                player_energy_drain = 0
                    if moving_y == -1:
                        globey -= moving_y*3
                        player.rect.top += moving_y*3
                        if moving_x != 0 or moving_y != 0:
                            player_energy_drain += 1
                            if player_energy_drain >= 15:
                                player_energy -= 1
                                player_energy_drain = 0
                else:
                    if timer.cur_time < timer.duration - 5:
                        timer.cur_time = timer.duration - 5

                if player.rect.left <= 0:
                    player.rect.left += 3
                    globex -= 3
                if player.rect.right >= 40*50:
                    player.rect.right -= 3
                    globex += 3
                if player.rect.top <= 0:
                    player.rect.top += 3
                    globey -= 3
                if player.rect.bottom >= 40*50:
                    player.rect.bottom -= 3
                    globey += 3

                for p_har in player_harvesters:
                    try:
                        if not p_har.have_fish:
                            if not p_har.rect.colliderect(p_har.closest_neut.rect):
                                p_har.move()
                            else:
                                p_har.damage_counter += 1
                                p_har.on_animation = "harvesting"
                                if p_har.damage_counter == 15:
                                    p_har.have_fish = True
                                    for neut in neut_group:
                                        if p_har.closest_neut.rect.center == neut.rect.center:
                                            try:
                                                neut.school -= 1
                                            except:pass
                        else:
                            if not p_har.rect.colliderect(player.rect):
                                p_har.move()
                            else:
                                player_energy += 50
                                player.crew += 1
                                player_harvesters.remove(p_har)
                    except:
                        pass
                        
                    
                for p_attack in player_attackers:
                    p_attack.should_move = True
                    p_attack.update(player_attack_target)
                    if p_attack.duration >= 225:
                        shark_eaters.append(units.SharkEat(p_attack.rect))
                        player_attackers.remove(p_attack)
                    if not p_attack.rect.colliderect(enemy.rect):
                        pass
                    else:
                        if p_attack.detonate == False:
                            p_attack.should_move = False
                            p_attack.on_animation = "attacking"
                            p_attack.damage_counter += 1
                            if p_attack.damage_counter == 25:
                                enemy.hull_health -= random.randint(p_attack.damage[0],p_attack.damage[1])
                                p_attack.damage_counter = 0
                        else:
                            sound_boom.play()
                            enemy.hull_health -= random.randint(p_attack.damage[0],p_attack.damage[1])
                            player_explosions.append(units.Explosion((p_attack.rect.left,p_attack.rect.top)))
                            player_attackers.remove(p_attack)

                for p_attack in player_attackers:
                    for decoy in decoys:
                        if not p_attack.rect.colliderect(decoy.rect):
                            pass
                        else:
                            if p_attack.detonate == False:
                                p_attack.should_move = False
                                p_attack.on_animation = "attacking"
                                p_attack.damage_counter += 1
                                if p_attack.damage_counter == 25:
                                    decoy.hull_health -= random.randint(p_attack.damage[0],p_attack.damage[1])
                                    p_attack.damage_counter = 0
                            else:
                                sound_boom.play()
                                decoy.hull_health -= random.randint(p_attack.damage[0],p_attack.damage[1])
                                player_explosions.append(units.Explosion(p_attack.rect))
                                player_attackers.remove(p_attack)

                for p_attack in player_attackers:
                    if p_attack.should_move == True:
                        p_attack.move(rocks)

                for e_attack in enemy_attackers:
                    e_attack.update(player)
                    if e_attack.duration >= 175:
                        shark_eaters.append(units.SharkEat(e_attack.rect))
                        enemy_attackers.remove(e_attack)
                    if not e_attack.rect.colliderect(player.rect):
                        e_attack.move(rocks)
                    else:
                        if e_attack.detonate == False:
                            e_attack.on_animation = "attacking"
                            e_attack.damage_counter += 1
                            if e_attack.damage_counter == 25:
                                player.hull_health -= random.randint(e_attack.damage[0],e_attack.damage[1])
                                e_attack.damage_counter = 0
                        else:
                            sound_boom.play()
                            player.hull_health -= random.randint(e_attack.damage[0],e_attack.damage[1])
                            player_explosions.append(units.Explosion(e_attack.rect))
                            enemy_attackers.remove(e_attack)

                for e_attack in decoy_attackers:
                    e_attack.update(player)
                    if e_attack.duration >= 175:
                        shark_eaters.append(units.SharkEat(e_attack.rect))
                        decoy_attackers.remove(e_attack)
                    if not e_attack.rect.colliderect(player.rect):
                        e_attack.move(rocks)
                    else:
                        if e_attack.detonate == False:
                            e_attack.on_animation = "attacking"
                            e_attack.damage_counter += 1
                            if e_attack.damage_counter == 25:
                                player.hull_health -= random.randint(e_attack.damage[0],e_attack.damage[1])
                                e_attack.damage_counter = 0
                        else:
                            sound_boom.play()
                            player.hull_health -= random.randint(e_attack.damage[0],e_attack.damage[1])
                            player_explosions.append(units.Explosion(e_attack.rect))
                            decoy_attackers.remove(e_attack)


                for decoy in decoys:
                    if player.really_big_rect.colliderect(decoy.rect):
                        decoy_attack_counter += 1
                        if decoy_attack_counter >= 35:
                            decoy_attack_counter = 0
                            if len(decoy_attackers) <= 4:
                                num = random.randint(0,19)
                                if num >= 0 and num <= 12:
                                    decoy_attackers.append(units.PiranhaAttack(decoy.rect, player))
                                elif num >= 13 and num <= 17:
                                    decoy_attackers.append(units.SharkAttack(decoy.rect, player))
                                else:
                                    decoy_attackers.append(units.HerringTorpedo(decoy.rect, player))
                                
                if player.really_big_rect.colliderect(enemy.rect):
                    enemy_attack_counter += 1
                    if enemy_attack_counter >= 35:
                        enemy_attack_counter = 0
                        if len(enemy_attackers) <= 4:
                            num = random.randint(0,19)
                            if num >= 0 and num <= 8:
                                enemy_attackers.append(units.PiranhaAttack(enemy.rect, player))
                            elif num >= 9 and num <= 12:
                                enemy_attackers.append(units.SharkAttack(enemy.rect, player))
                            else:
                                enemy_attackers.append(units.HerringTorpedo(enemy.rect, player))
                            


                if player.big_rect.colliderect(enemy.rect):
                    player_attack_target = enemy
                else:
                    for decoy in decoys:
                        if player.big_rect.colliderect(decoy.rect):
                            player_attack_target = decoy
                
                    

                if enemy.hull_health <= 0:
                    sound_big_boom.play()
                    self.on_state = "Next-Level"
                    self.level += 1
                    break
                for decoy in decoys:
                    if decoy.hull_health <= 0:
                        sound_big_boom.play()
                        decoys.remove(decoy)
                if timer.cur_time == timer.duration:
                    sound_big_boom.play()
                    sound_big_boom.play()
                    sound_big_boom.play()
                    self.on_state = "End"
                    break
                if player.hull_health <= 0:
                    sound_big_boom.play()
                    self.on_state = "End"
                    break

                    
                if moving_y == 1:
                    if moving_x == 1:
                        player.facing = 5#correct
                    if moving_x == 0:
                        player.facing = 3#correct
                    if moving_x == -1:
                        player.facing = 1#correct
                if moving_y == 0:
                    if moving_x == 1:
                        player.facing = 7#correct
                    if moving_x == 0:
                        pass             #correct
                    if moving_x == -1:
                        player.facing = 15#correct
                if moving_y == -1:
                    if moving_x == 1:
                        player.facing = 9
                    if moving_x == 0:
                        player.facing = 11
                    if moving_x == -1:
                        player.facing = 13

                if moving_x == 0:
                    if moving_y == 0:
                        player.on_animation = "still"
                    else:
                        player.on_animation = "moving"
                else:
                    player.on_animation = "moving"


                for inc in p_sonar.incoming:
                    p_sonar.remove_incoming(inc)
                for inc in enemy_attackers:
                    p_sonar.add_incoming(inc)
                for inc in decoy_attackers:
                    p_sonar.add_incoming(inc)

                p_sonar.sweep_from( ( int(player.rect.left/50) ,int(player.rect.top/50) ) )
                p_sonar.sweep_map()
                our_map.draw(self.background_screen)
                our_map.globex, our_map.globey = globex, globey
                for p_har in player_harvesters:
                    p_har.draw(self.background_screen, globex, globey)
                    p_har.update(player)
                    if p_har.duration >= 250:
                        shark_eaters.append(units.SharkEat(p_har.rect))
                        player_harvesters.remove(p_har)
                for explosion in player_explosions:
                    explosion.draw(self.background_screen, globex, globey)
                    if explosion.ended == True:
                        player_explosions.remove(explosion)
                for shark in shark_eaters:
                    shark.draw(self.background_screen, globex, globey)
                    if shark.ended == True:
                        shark_eaters.remove(shark)
                for a in ambience_group:
                    a.draw(self.background_screen, globex, globey)
                for rock in rocks:
                    rock.draw(self.background_screen, globex, globey)
                for p_attack in player_attackers:
                    p_attack.draw(self.background_screen, globex, globey)
                for e_attack in enemy_attackers:
                    e_attack.draw(self.background_screen, globex, globey)
                player.draw(self.background_screen, globex, globey)
                player_base.draw(self.background_screen, globex, globey)
                player.update()
                enemy.draw(self.background_screen, globex, globey)
                enemy.update(rocks)
                for decoy in decoys:
                    decoy.draw(self.background_screen, globex, globey)
                    decoy.update(rocks)
                for d_attack in decoy_attackers:
                    d_attack.draw(self.background_screen, globex, globey)
                for neut in neut_group:
                    if neut.school <= 0:
                        try:
                            neut_group.remove(neut)
                        except:pass
                    neut.draw(self.background_screen, globex, globey)
                exit_button.draw(self.background_screen, 'exit')

                timer.update(self.level, player_energy, player.hull_health, player.crew)
                p_sonar.draw(self.background_screen)
                timer.draw(self.background_screen)
            else:
                our_map.draw(self.background_screen)
                our_map.globex, our_map.globey = globex, globey
                for p_har in player_harvesters:
                    p_har.draw(self.background_screen, globex, globey)
                for rock in rocks:
                    rock.draw(self.background_screen, globex, globey)
                for p_attack in player_attackers:
                    p_attack.draw(self.background_screen, globex, globey)
                for e_attack in enemy_attackers:
                    e_attack.draw(self.background_screen, globex, globey)
                player.draw(self.background_screen, globex, globey)
                player_base.draw(self.background_screen, globex, globey)
                enemy.draw(self.background_screen, globex, globey)
                for decoy in decoys:
                    decoy.draw(self.background_screen, globex, globey)
                for d_attack in decoy_attackers:
                    d_attack.draw(self.background_screen, globex, globey)
                for neut in neut_group:
                    neut.draw(self.background_screen, globex, globey)
                exit_button.draw(self.background_screen, 'exit')

                timer.draw(self.background_screen)
            pygame.display.flip()

    def levelup(self):
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("youpassed.png", alpha = True)
        play_button = gui.Button(550, 425, 'button.png', True)
        play_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20)
        m1 = font.render(str(self.level),0,[0,0,255])

        left_play = True

        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if play_button.clicked(m_d) == True:
                self.on_state = "Play"
                break

            if play_button.do_hl == True:
                if left_play == True:
                    sound_pong.play()
                    left_play = False
            else:
                left_play = True
            self.background_screen.blit(back, (0,0))
            play_button.draw(self.background_screen, "continue")
            self.background_screen.blit(m1, (475, 310))
            pygame.display.flip()
            
    def end(self):
        music = pygame.mixer
        music.init()
        music.music.load(os.path.join('data', 'menu.ogg'))
        sound_pong = loading.load_sound('pong.wav')
        sound_pong.set_volume(0.3)
        music.music.play()
        back, r = loading.load_image("youlost.png", alpha = True)
        menu_button = gui.Button(550, 425, 'button.png', True)
        menu_button.Set_Font(font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20), color = [0,0,0])
        m_d = False

        left_menu = True

        while 1:
            m_d = False
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        m_d = True
            if menu_button.clicked(m_d) == True:
                self.on_state = "Menu"
                break

            if menu_button.do_hl == True:
                if left_menu == True:
                    sound_pong.play()
                    left_menu = False
            else:
                left_menu = True
            self.background_screen.blit(back, (0,0))
            menu_button.draw(self.background_screen, "main menu")
            pygame.display.flip()


game = game_states()
while 1:
    if game.on_state == "Menu":
        game.menu()

    elif game.on_state == "INST-1":
        game.inst_one()

    elif game.on_state == "INST-2":
        game.inst_two()

    elif game.on_state == "INST-3":
        game.inst_three()

    elif game.on_state == "INST-4":
        game.inst_four()
        
    elif game.on_state == 'Play':
        game.play()

    elif game.on_state == 'Next-Level':
        game.levelup()

    elif game.on_state == 'End':
        game.end()

    elif game.on_state == "Exit-Now":
        pygame.quit()
        break
    else:
        break
#profile.run('game.play()')
