import loading
from loading import *

class Player_Timer:
    def __init__(self, duration):
        self.duration = duration
        self.finished = False
        self.cur_time = 0
        self.whirly = 0
        self.font = pygame.font.Font(os.path.join('data', 'Advert-Regular.ttf'), 20)
        self.i_crew, r = load_image('gui-crew.png', alpha=True)
        self.i_level, r = load_image('gui-level.png', alpha=True)
        self.i_health, r = load_image('gui-hull.png', alpha=True)
        self.i_time, r = load_image('gui-timeleft.png', alpha=True)
        self.i_energy, r = load_image('gui-energy.png', alpha=True)
        self.color = [85,85,85]
        self._lev = 0
        self._scr = 0
        self._phealth = 0
        self._crew = 0
        #scr = energy!

    def update(self, level, score, player_health, crew):
        self._lev = level
        self._scr = score
        self._phealth = player_health
        self._crew = crew
        self.whirly += 1
        if self.whirly == 20:
            self.cur_time += 1
            self.whirly = 0
        if self.cur_time >= self.duration:
            self.finished = True

    def draw(self, surf):
        m1 = self.font.render(str(self.duration-self.cur_time),0,self.color)
        m2 = self.font.render(str(self._lev),0,self.color)
        m3 = self.font.render(str(self._scr),0,self.color)
        m4 = self.font.render(str(self._phealth),0,self.color)
        m5 = self.font.render(str(self._crew),0,self.color)
        surf.blit(self.i_time, (25, 445))
        surf.blit(m1, (125, 445))
        surf.blit(self.i_level, (160, 445))
        surf.blit(m2, (225, 445))
        surf.blit(self.i_energy, (255, 445))
        surf.blit(m3, (335, 445))
        surf.blit(self.i_health, (400, 445))
        surf.blit(m4, (455, 445))
        surf.blit(self.i_crew, (505, 445))
        surf.blit(m5, (570, 445))
        return
